function [cntArr30x100] = makeCntArr30x100(corArr12, startClick0, endClick0)
    
    % Tar inn corArr12 for å få clock0 tider
    
    % Generer geno
    % generer paraArr for sample 30 fps
    
    %
    
    
    
    corArr12_30x100 = genCorArr12_30x100(corArr12, startClick0, endClick0);
    
    corArr12_30x100 = addPara(corArr12_30x100, startClick0, endClick0);
    
    cntArr30x100 = makeCntArr30(corArr12_30x100);
    
end

%%

function [cntArr30x100] = makeCntArr30(corArr12_30x100)
    % Her samples med 30hz
    
    fN = 30;
    
    endTime = corArr12_30x100(end, 1);
    antSampl = floor(fN*endTime/1000);
    
    %sNOff =
    
    cntArr30x100 = zeros(antSampl, 2);
    
    paraArr12 = corArr12_30x100(:, 4:11);
    clickArr12 = corArr12_30x100(:, 1); % Tider for para val i ms   
    
    paraIndexTeller = 1;
    A = 0;
    B = 0;
    D = 0;
    T = 1;
    % Kanal 1
    for sNr = 1 : length(cntArr30x100) % sampleNr
        if paraIndexTeller <= length(paraArr12)
            if sNr > fN*clickArr12(paraIndexTeller)/1000 % click2sNr, interpolerer, og legger inn ny keyframe når behov
                A = paraArr12(paraIndexTeller, 1);
                B = paraArr12(paraIndexTeller, 2);
                D = paraArr12(paraIndexTeller, 3);
                T = paraArr12(paraIndexTeller, 4);
                
                paraIndexTeller = paraIndexTeller + 1;
            end
        end
        
        cntArr30x100(sNr, 1) = A*cos(2*pi*(sNr - D)/T) + B;
    end
    
    paraIndexTeller = 1;
    A = 0;
    B = 0;
    D = 0;
    T = 1;
    % Kanal 2
    for sNr = 1 : length(cntArr30x100) % sampleNr
        if paraIndexTeller <= length(paraArr12)
            if sNr > fN*clickArr12(paraIndexTeller)/1000 % click2sNr, interpolerer, og legger inn ny keyframe når behov
                A = paraArr12(paraIndexTeller, 1+4);
                B = paraArr12(paraIndexTeller, 2+4);
                D = paraArr12(paraIndexTeller, 3+4);
                T = paraArr12(paraIndexTeller, 4+4);
                
                paraIndexTeller = paraIndexTeller + 1;
            end
        end
        
        cntArr30x100(sNr, 2) = A*cos(2*pi*(sNr - D)/T) + B;
    end    
    
end

%%
function [corArr12_30x100] = addPara(corArr12_30x100, startClick0, endClick0)
    
    % Først kanal 1
    currYval = 0;
    currClick = 1;
    for i = 1 : size(corArr12_30x100, 1)
        if corArr12_30x100(i, 2) > 0 % Har funnet en ny start/slutt verdi
            oldYval = currYval;
            oldClick = currClick;
            currYval = (corArr12_30x100(i, 2) - 5)/4; % Legger inn ny Y verdi sentrert rundt 5 i currclick i
            currClick = i;
            
            x1 = corArr12_30x100(oldClick, 1); % x til click-1
            x2 = corArr12_30x100(currClick, 1);
            y1 = oldYval;
            y2 = currYval;
            
            [A, B, D, T] = findPara(x1, y1, x2, y2);
            for ii = oldClick : currClick - 1
                corArr12_30x100(ii, 4:7) = [A, B, D, T];
            end
        end
    end
    
    % Så kanal 2
    currYval = 0;
    currClick = 1;
    for i = 1 : size(corArr12_30x100, 1)
        if corArr12_30x100(i, 3) > 0 % Har funnet en ny start/slutt verdi
            oldYval = currYval;
            oldClick = currClick;
            currYval = (corArr12_30x100(i, 3) - 5)/4; % Legger inn ny Y verdi sentrert rundt 5 i currclick i
            currClick = i;
            
            x1 = corArr12_30x100(oldClick, 1); % x til click-1
            x2 = corArr12_30x100(currClick, 1);
            y1 = oldYval;
            y2 = currYval;
            
            [A, B, D, T] = findPara(x1, y1, x2, y2);
            for ii = oldClick : currClick - 1
                corArr12_30x100(ii, 4+4:7+4) = [A, B, D, T];
            end
        end
    end
    
end

%%
function [corArr12_30x100] = genCorArr12_30x100(corArr12, startClick0, endClick0)
    % Lager kun tider og 1-9 val, der tider shiftes ned mot 0
    %
    % 2 kanaler med (0)1-9, 100 indiv
    % random gen
    % prob 0.1 for keyframe på en click12
    % prob 0.3 for keyframe på en click0
    % 3 (click12) min avstand mellom keyframes
    
    prob0 = 1 - 0.5;
    prob12 = 1 - 0.1;
    
    antKey12frames = 12 * (endClick0 - startClick0 + 1);
    
    corArr12_30x100 = zeros(antKey12frames, 1+2+2*4, 1);
    
    old = 0;
    oldOld = 0;
    for indiv = 1 : 1
        for ch = 1 : 2
            for key = 1 : antKey12frames
                if old == 0 && oldOld == 0 % 3 (click12) min avstand mellom keyframes
                    if mod(key-1, 12) == 0 % er click0 frame
                        if rand(1) > prob0
                            corArr12_30x100(key, ch+1, indiv) = floor(rand(1)*9 + 1);
                        end
                    else % er click12 frame
                        if rand(1) > prob12
                            corArr12_30x100(key, ch+1, indiv) = floor(rand(1)*9 + 1);
                        end
                    end
                end
                oldOld = old;
                old = corArr12_30x100(key, ch+1, indiv);
            end
        end
    end
    
    % click12offsett
    click12offsett =  12 * (startClick0 - 1) + 1;
    
    % Klipper inn tider fra orginal
    corArr12_30x100(1:end, 1, 1) = corArr12(click12offsett : click12offsett + antKey12frames - 1, 1);
    
    % Shifter mot 0
    corArr12_30x100(:, 1) = corArr12_30x100(:, 1) - corArr12_30x100(1, 1, 1);
    
end










