function plotCurves44(musArr44, cntArr44, corArr12, corStrArr, startClick,  antClick, selectionRange, modi)

    % musArr44
    %  || sinClickArr44
    %  | clickArr12_44
    %  cntArr44 ch2
    %  cntArr44 ch1
    % Alle kurver må være sentrert i 0 og gå fra -0.5 til +0.5
    % Vindu Yakse går fra 0 (topp) til -8 (bunn) 
    
    %close;  
    
    clickArr = str2double(corStrArr(:, 1));
    clickArr12 = corArr12(:, 1);
    
    fs = 44100;
    
    endClick = startClick + antClick;
    
    if startClick == 0
        startSampl = 1;
    else
        startSampl = cl2sa(corStrArr, startClick);
    end
    startSampl = max(startSampl, 1);
    
    if startClick + antClick > size(clickArr, 1)
        endSampl = size(musArr44, 1);
    else
        endSampl = min([cl2sa(corStrArr, startClick + antClick)  size(musArr44, 1)]); 
    end  
    
    sz = get(0,'ScreenSize'); % xStart yStartFraBunn bredde høyde
    fontSise = 8;
    vindusHoyde = sz(4)/2; % I piksler basis screenHeigth
    wavAmplitude = 0.3;
    axer = [startSampl endSampl -8 0];    
    
    textXoffset = (endSampl - startSampl) / 120; % For å shifte text litt
    
    offWav = 0.02; % Før
    hoyWav = 2*wavAmplitude; % Peak to peak
    offKurv1 = 0.15; % Før første
    hoyKurv = 3; % Peak to peak
    offKurvN = 0.15; % Før Nte 
    offText = 0.2; % Før hver kommentar linje
    offAgent = 1.6;
    scalAgent = 0.6;
    
    tittel = ['pilOpp: zoomUt - - - pilNed: zoomInn - - - pilH: panH - - - pilV: panV - - - <: panV - - -  >: panH'];
    tittel = [tittel  'p: play - - - x: preview - - - X: previewSakte - - - x: previewEndaSaktere  - - - '];
    tittel = [tittel 'r: reload - - - q: quit - - - d: demo - - - D: demoSlow - - - o: run Ordive'];
    figure(1);clf;
    set(gcf, 'NumberTitle', 'off','name', tittel, 'MenuBar', 'none','position', [0 sz(4)-vindusHoyde sz(3) vindusHoyde],'color', [0.08 0.08 0.08]);
    
    cntArr44 = cntArr44 .* hoyKurv;
 
    %% Musikk wav
    musArr44 = wavAmplitude*(musArr44(:, 1) + musArr44(:, 2))/2; % -0.5 til 0.5
    off = offWav + hoyWav/2;
    plot([startSampl : endSampl], musArr44(startSampl : endSampl) - off, 'color', [1 0.2 0.2]);
    % Click nr   
    for i = max([startClick 1]) : endClick
        samplXval = cl2sa(corStrArr, i);
        text(samplXval, -offWav-hoyWav, num2str(i), 'color', [0.7 0.7 1], 'fontSize', fontSise); % Click nummer 
    end    
    hold on;
    
    %% Kontroll kurver
    
    % KURVE 1 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    off = off + hoyWav/2 + offKurv1 + hoyKurv/2 -0.4;
    line([startSampl endSampl], [-off, -off], 'color', [0.4 0.4 0.4]);
    line([startSampl endSampl], [-off+0.25, -off+0.25], 'color', [0.4 0.1 0.1]);
    line([startSampl endSampl], [-off-0.25, -off-0.25], 'color', [0.4 0.1 0.1]);
    plot([startSampl : endSampl], cntArr44(startSampl :  endSampl, 1)/4 - off, 'color', [0.6 0.6 1]); % Kurven
    % Click1 linjer  
    for i = max([startClick 1]) : endClick
        samplXval = cl2sa(corStrArr, i);
        line([samplXval, samplXval], [-off-hoyKurv/4, -off+hoyKurv/4], 'color', [1 0 0]);
    end
    % Click12 linjer  
    for i = max([startClick 1]) - 1 : endClick
        for ii = 1 : 12
            samplXval = floor(fs*clickArr12(i*12 + ii)/1000); 
            line([samplXval samplXval], [-off-hoyKurv/4, -off+hoyKurv/4], 'color', [0.8 0 0], 'LineStyle', ':');
        end
    end 
    % Punkter o og text val
    for i = max([startClick 0])  : endClick
        for ii = 1 : 12 % 1-9
            samplXval = floor(fs*clickArr12(i*12 + ii)/1000);
            samplXval = max([samplXval 1]);
            c1 = corArr12(i*12 + ii, 2);
            if c1 > 0
                text(samplXval, -off + cntArr44(samplXval, 1)/4 + 0.12, num2str(c1), 'color', [1 1 1], 'fontSize', fontSise); % u d 0
                if selectionRange(1) < samplXval && samplXval < selectionRange(2) 
                    plot(samplXval, -off + cntArr44(samplXval, 1)/4, 'o', 'color', [1 1 1], 'MarkerSize',8, 'MarkerFaceColor', [1 1 1]);
                else
                    plot(samplXval, -off + cntArr44(samplXval, 1)/4, 'o', 'color', [0.7 0.7 1]);
                end
            end            
        end
    end
    
    % Kurve nummer
    text(startSampl - textXoffset, -off, 'c1', 'color', [1 1 .1], 'fontSize', fontSise);
    
    % KURVE 2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    off = off + offKurvN + hoyKurv/2; 
    line([startSampl endSampl], [-off, -off], 'color', [0.4 0.4 0.4]);
    line([startSampl endSampl], [-off+0.25, -off+0.25], 'color', [0.4 0.1 0.1]);
    line([startSampl endSampl], [-off-0.25, -off-0.25], 'color', [0.4 0.1 0.1]);
    plot([startSampl : endSampl], cntArr44(startSampl :  endSampl, 2)/4 - off, 'color', [0.6 0.6 1]); % Kurven
    % Click1 linjer og click nr   
    for i = max([startClick 1]) : endClick
        samplXval = cl2sa(corStrArr, i);
        line([samplXval, samplXval], [-off-hoyKurv/4, -off+hoyKurv/4], 'color', [1 0 0]);
    end
    % Click12 linjer  
    for i = max([startClick 1]) - 1 : endClick
        for ii = 1 : 12
            samplXval = floor(fs*clickArr12(i*12 + ii)/1000); 
            line([samplXval samplXval], [-off-hoyKurv/4, -off+hoyKurv/4], 'color', [0.8 0 0], 'LineStyle', ':');
        end
    end 
    % Punkter o og text val
    for i = max([startClick 0])  : endClick
        for ii = 1 : 12 % 1-9
            samplXval = floor(fs*clickArr12(i*12 + ii)/1000);
            samplXval = max([samplXval 1]);
            c1 = corArr12(i*12 + ii, 3);
            if c1 > 0
                text(samplXval, -off + cntArr44(samplXval, 2)/4 + 0.12, num2str(c1), 'color', [1 1 1], 'fontSize', fontSise); % u d 0
                if selectionRange(1) < samplXval && samplXval < selectionRange(2) 
                    plot(samplXval, -off + cntArr44(samplXval, 2)/4, 'o', 'color', [1 1 1], 'MarkerSize',8, 'MarkerFaceColor', [1 1 1]);
                else
                    plot(samplXval, -off + cntArr44(samplXval, 2)/4, 'o', 'color', [0.7 0.7 1]);
                end
            end            
        end
    end    
    
    % Kurve nummer
    text(startSampl - textXoffset, -off, 'c2', 'color', [1 1 .1], 'fontSize', fontSise);    
    
    %%
    set(gca, 'Position', [0.03 0.03 0.95 0.95]); % venstre bunn høyre høyde
    axis tight; axis(axer); axis off;
       
    % COR txt og agent
    off = off + offText + hoyKurv/4;
    oldCom2 = "";
    for i = max([startClick 0])  : endClick
        % Komments
        samplXval = cl2sa(corStrArr, i+1);
        c = corStrArr(i+1, 3); % movX
        text(samplXval, -off, c, 'color', [.3 0.3 1], 'fontSize', fontSise);
        c = corStrArr(i+1, 4); % comm nivå 1
        text(samplXval, -off-offText, c, 'color', [1 1 .1], 'fontSize', fontSise);
        c = corStrArr(i+1, 5); % comm nivå 2
        text(samplXval, -off-offText*2, c, 'color', [1 0.5 .1], 'fontSize', fontSise); 
        if c ~= "" && c == oldCom2
            line([cl2sa(corStrArr, i+1) cl2sa(corStrArr, i)], [-off-offText*3 -off-offText*3], 'color', [0.4 0.4 0.4]); % Linje under Com2
        end
        oldCom2 = c;
        
        % Agent
        for ii = 1 : 12 % 1-9
            samplXval = floor(fs*clickArr12(i*12 + ii)/1000);
            samplXval = max([samplXval 1]);
            c1 = corArr12(i*12 + ii, 3);
            c2 = corArr12(i*12 + ii, 2);

            if c1 > 0 || c2 > 0
                plotAgent2(cntArr44(samplXval+1, 1)./hoyKurv, cntArr44(samplXval+1, 2)./hoyKurv, samplXval, -off-offText*2-offAgent, scalAgent);
            end
        end        
    end
    
  text(startSampl + (endSampl-startSampl)/4, -7.7, 'Select','color',[1 .8 .2], 'fontSize', fontSise);
    
end
