%%
clear;

[musArr44, ~] = audioread('wavInp/musZorg.wav');                    % (Mx2) stereo musikk samples
corStrArr = corReadFile('work/cor_Zstd_agent1.txt');                % ClickTid(ms) clickNr moves comm1 comm2

fs = 44100;
corArr12 = makeCorArr12(corStrArr);                                 % Click12Time(ms)  ch1val cha2val  para1a para1b para1c para1d  para1a para1b para1c para1d
sinClickArr44 = makeSinClickArr44(corStrArr, musArr44);              % (Mx2) stereo sinus clicks
sinClickArr44 = addCommentToSinClick44(sinClickArr44, corStrArr);
cntArr44 = makeCntArr44(corArr12, size(musArr44, 1));  % (M*2x1) 44100Hz kontroll kurver

%% Plotter musikk og alt
plotCurves44(musArr44, cntArr44, corArr12, corStrArr, 0, 13, [0 0], 'std');
gui;

%% Hører musikk i lag med klikk
playMusAndClick(musArr44, sinClickArr44);

%% Lager clickArray (Nx1) manuelt fra musArray (Mx2) mens musikk spilles av
makeClickArrKeyboard(musArr44); % først denne % s-start, q-quit, c-click
clickArr = getappdata(0, 'clickArrayApp'); close; % også denne
corStrArr(:, 1) = string(clickArr)'; 

% Retter opp clicks manuelt
backClickArr = clickArr;
% clickArray = backClickArray;
for i = 1 : 50
    g = ginput(1);
    cNr = findNermestClick(g(1), corStrArr);
    mNr = findNermestWav(musArr44, g(1), g(2));
    line([mNr mNr], [1 -1], 'Color', [1 0 0]);
    line([mNr 44100*str2double(corStrArr(cNr, 1))/1000], [-1 -1], 'Color', [1 0 0]);
    corStrArr(cNr, 1) = num2str(floor(1000*g(1)/fs));
end

% Justerer bro mellom clicks
clickNrStart = 322; % Fra og ikke med
clickNrEnd = 327; % Til og ikke med
corStrArr = makeClickBridge(clickNrStart, clickNrEnd, corStrArr); 

%% COR
corStrArr = corFillInMoves(corStrArr, 'movStd', 1, 14);
corSaveFile('work/cor_Zstd_agent1.txt', corStrArr);
corStrArr = corMoveMoves(corStrArr, 14, 24, 1);
corStrArr = corBridgeCom2(corStrArr, 300);

corStrArr = corReadFile('work/cor_Zstd_agent1.txt');

corSaveFile('work/cor_Zstd_agent1.txt', corStrArr);

corSaveFile('work/cor_Zstd_agent1.txt',corReadFile('work/cor_Zstd_agent1.txt'));

runPreview(musArr44, sinClickArr44, cntArr44, floor(44100/3));

%% 3D preview uten lyd

frameRate = 30;
vidObj = VideoReader('vidInp/oSmall.mov'); % IN
fs2 = 44100/8;
figure(4); clf; set(gcf,'Position',[100 100 1280 720]);

% Gulv - sjakkmønster
[F, V] = polyQuadFloor(11, 11);
cV = 0.2*ones(11*11, 3);
for i = 1 : 2 : 11*11
    cV(i, :) = [0.9 0.9 0.9];
end
plotPoly(F, 10*V, 'dark', 'col', cV);

% Soyle
load 'grafikk/soyle.mat';
plotPoly(F, 4*V+[-11/2 0 0], 'dark', 'col', [0.2 0.2 1], 'edgeOff');
plotPoly(F, 4*V+[11/2 0 0], 'dark', 'col', [0.2 0.2  1], 'edgeOff');

% Agent
[F, V] = agent1(0, 0, 'demo'); V1 = 4*V+[-11/2 0 4]; V2 = 4*V+[11/2 0 4];
ha1 = plotPoly(F, V1, 'dark', 'col', [1 0.2 .2], 'edgeOff');
ha2 = plotPoly(F, V2, 'dark', 'col', [1 0.2 .2], 'edgeOff');

% Lerret
[F, V] = polyQuadFloor(120, 80); V = 6*(rotx(90)*V')' + [0 10 5];
hl = plotPoly(F, V, 'col', rand(120*80, 3), 'dark', 'edgeOff');

view(20,12);
axis([-9.0549    1.3779    8.9569   19.3896    2.8030    4.9065]);

ccOld = 0;
for s = cl2sa(corStrArr, 64) : floor(fs/frameRate) : cl2sa(corStrArr, 75) % manuell intastn
    ccc = findNermestClick(s, corStrArr);
    if ccc > ccOld
       disp(ccc); 
       ccOld = ccc;
    end
    % Agent
    [~, V] = agent1(cntArr44(s, 1), cntArr44(s, 2), 'demo'); V1 = 4*V+[-11/2 0 4]; V2 = 4*V+[11/2 0 4];
    set(ha1, 'Vertices', V1);
    set(ha2, 'Vertices', V2);
    
    % Video in
    vidObj.CurrentTime = s/fs;
    frame = readFrame(vidObj); frame = flipud(frame); frame = permute(frame,[2 1 3]);
    co1 = double(squeeze(reshape(frame,[], 80*120,3))); co1 = co1/max(max(co1));
    set(hl, 'FaceVertexCData', co1);
    pause(0.2);
    drawnow; 
    
end


%% Lage film

frameRate = 60;
vidObj = VideoReader('vidInp/o.mov'); % IN
vidfile = VideoWriter('vidOut/testmov', 'Uncompressed AVI');  vidfile.FrameRate = frameRate; open(vidfile); % UT

figure(2); clf; set(gcf,'Position',[100 100 1280 720]);

% Gulv - sjakkmønster
[F, V] = polyQuadFloor(11, 11);
cV = 0.2*ones(11*11, 3);
for i = 1 : 2 : 11*11
    cV(i, :) = [0.9 0.9 0.9];
end
plotPoly(F, 10*V, 'dark', 'col', cV);

% Soyle
load 'grafikk/soyle.mat';
plotPoly(F, 4*V+[-11/2 0 0], 'dark', 'col', [0.2 0.2 1], 'edgeOff');
plotPoly(F, 4*V+[11/2 0 0], 'dark', 'col', [0.2 0.2 1], 'edgeOff');

% Agent
[F, V] = agent1(0, 0, 'demo'); V1 = 4*V+[-11/2 0 4]; V2 = 4*V+[11/2 0 4];
ha1 = plotPoly(F, V1, 'dark', 'col', [1 0.2 .2], 'edgeOff');
ha2 = plotPoly(F, V2, 'dark', 'col', [1 0.2 .2], 'edgeOff');

% Lerret
[F, V] = polyQuadFloor(1280, 720); V = 6*(rotx(90)*V')' + [0 10 5];
hl = plotPoly(F, V, 'col', rand(1280*720, 3), 'dark', 'edgeOff');

view(20,12);
axis([-8.9547    5.5293    1.2987   15.7826    1.2208    4.1410]);

for s = 1 : floor(fs/frameRate) : cl2sa(corStrArr, 3) % manuell intastn
    ccc = findNermestClick(s, corStrArr);
    set(gcf, 'name', num2str(ccc));
    % Agent
    [~, V] = agent1(cntArr44(s, 1), cntArr44(s, 2), 'demo'); V1 = 4*V+[-11/2 0 4]; V2 = 4*V+[11/2 0 4];
    set(ha1, 'Vertices', V1);
    set(ha2, 'Vertices', V2);
    
    % Video in
    %vidObj.CurrentTime = s/fs;
    %frame = readFrame(vidObj); frame = flipud(frame); frame = permute(frame,[2 1 3]);
    frame = read(vidObj, floor(25*s/fs)+1); frame = flipud(frame); frame = permute(frame,[2 1 3]); 
    co1 = double(squeeze(reshape(frame,[], 720*1280,3))); co1 = co1/max(max(co1));
    set(hl, 'FaceVertexCData', co1);
    
    set(gca,'CameraPositionMode','manual');
    set(gca,'CameraViewAngleMode','manual');
    set(gca,'CameraTargetMode','manual');
    set(gca,'CameraPosition',[12 -20 5]);
    set(gca,'CameraViewAngle',25);
    set(gca,'CameraTarget',[-1 10 5]);
    
    drawnow; 
    frame= getframe(gcf);
    %frame = addGenLibFrame( frame );
    %writeVideo(vidfile, frame);
end
close(vidfile);


%% FFMPEG rsync

% rsync --progress -a move matsh@login.ifi.uio.no:/uio/kant/ifi-ansatt-u00/matsh/
% rsync --progress -a matsh@login.ifi.uio.no:/uio/kant/ifi-ansatt-u00/matsh/move/ move

% ffmpeg -i Zorg.mp4 -c:v mjpeg -q:v 3 -an o.mov
% ffmpeg -i testmov.avi -ss 0 -i musZorg.wav -vcodec libx265 -crf 23 -shortest -vf vflip o3.mp4
% ffmpeg -i Zorg.mp4 -vf scale=120:80 -c:v mjpeg -q:v 3 -an oSmall.mov

% VideoWriter.getProfiles()
% KEY - (22) 35, 55, 102, 162, 226, 290
% ffmpeg -i testmov.avi -ss 0 -i w.wav -vcodec libx265 -crf 28 output.mp4
% ffmpeg -i input.flv -vcodec libx264 -acodec aac output.mp4
% ffmpeg -i testmov.avi -ss 0 -i musZorg.wav -vcodec libx265 -crf 23 -shortest output.mp4

% ffmpeg -i testmov.avi -ss 0 -i w.wav -vcodec copy -shortest outputRaaMedLyd.mp4
% -crf 28 er kvalitet lav bedre, 28 er default for 265, 23 er for 264

% https://cloudconvert.com/avi-to-mp4


